@use '@angular/material' as mat;
@use 'sass:map';
@use "skao-colour-theme" as skao-colours;

$values: (50, 100, 200, 300, 400, 500, 600, 700, 800, 900, A100, A200, A400, A700);

@function create-palette($main, $dark, $light, $contrast) {
  $palette: (
    50 : $light,
    100 : mix($main, $light, 20%),
    200 : mix($main, $light, 40%),
    300 : mix($main, $light, 60%),
    400 : mix($main, $light, 80%),
    500 : $main,
    600 : mix($main, $dark, 67%),
    700 : mix($main, $dark, 50%),
    800 : mix($main, $dark, 34%),
    900 : $dark,
    A100 : lighten(saturate($dark, 80%), 65%),
    A200 : lighten(saturate($dark, 80%), 55%),
    A400 : lighten(saturate($dark, 100%), 45%),
    A700 : lighten(saturate($dark, 100%), 40%)
  );

  $contrasts: ();
  @each $v in $values {
    $contrasts: map.merge($contrasts, ($v: $contrast))
  }

  $palette: map.merge($palette, (contrast: $contrasts));

  @return $palette;
}

$dark-primary-light: #484848;
$dark-primary-main: #212121;
$dark-primary-dark: #000000;
$dark-primary-contrast: #FFFFFF;

$dark-secondary-light: #FFF04E;
$dark-secondary-main: #F7BE00;
$dark-secondary-dark: #BF8E00;
$dark-secondary-contrast: #000000;

$dark-warn-light: #F5AB7F;
$dark-warn-main: #EF7C38;
$dark-warn-dark: #CA5510;
$dark-warn-contrast: #000000;

$light-primary-light: #F4F9FD;
$light-primary-main: #C1C6CA;
$light-primary-dark: #919599;
$light-primary-contrast: #000000;

$light-secondary-light: #472A97;
$light-secondary-main: #070068;
$light-secondary-dark: #00003D;
$light-secondary-contrast: #FFFFFF;

$light-warn-light: #FF3B93;
$light-warn-main: #E70068;
$light-warn-dark: #B10251;
$light-warn-contrast: #FFFFFF;

$custom-typography: mat.define-typography-config(
  $font-family: '"Noto Sans", sans-serif'
);

@include mat.core($custom-typography);

$md-light: create-palette($light-primary-main, $light-primary-dark, $light-primary-light, $light-primary-contrast);
$md-light-accent: create-palette($light-secondary-main, $light-secondary-dark, $light-secondary-light, $light-secondary-contrast);
$md-light-warn: create-palette($light-warn-main, $light-warn-dark, $light-warn-light, $light-warn-contrast);

$md-dark: create-palette($dark-primary-main, $dark-primary-dark, $dark-primary-light, $dark-primary-contrast);
$md-dark-accent: create-palette($dark-secondary-main, $dark-secondary-light, $dark-secondary-dark, $dark-secondary-contrast);
$md-dark-warn: create-palette($dark-warn-main, $dark-warn-dark, $dark-warn-light, $dark-warn-contrast);

$skao-theme-primary: mat.define-palette($md-light);
$skao-theme-accent: mat.define-palette($md-light-accent);
$skao-theme-warn: mat.define-palette($md-light-warn);
$skao-theme-dark: mat.define-palette($md-dark);
$skao-theme-dark-accent: mat.define-palette($md-dark-accent);
$skao-theme-dark-warn: mat.define-palette($md-dark-warn);

$skao-theme: mat.define-light-theme((
    color: (
      primary: $skao-theme-primary,
      accent: $skao-theme-accent,
      warn: $skao-theme-warn,
    )
   ));

$skao-dark-theme: mat.define-dark-theme((
    color: (
      primary: $skao-theme-dark,
      accent: $skao-theme-dark-accent,
      warn: $skao-theme-dark-warn,
    )
));

@include mat.all-component-themes($skao-theme);
@include skao-colours.color($skao-theme);

.dark-theme {
  @include mat.all-component-colors($skao-dark-theme);
  @include skao-colours.color($skao-dark-theme);
}

.footer {
    max-height: 32px;
    display: flex;
    flex-direction: column;
    font-size: 14px;
}

.skao-spacer {
    height: 5px;
    width: 100%;
}

.mat-icon-button {
  border: 3px solid !important;
}

.mat-button, .mat-raised-button  {
    font-weight: 700;
    font-size: 16px;
    text-transform: uppercase;
}

.mat-raised-button {
    margin: 10px !important;
    padding: 10px 20px 10px 20px !important;
}

.mat-tab-label {
    opacity: 1 !important;
}

.mat-form-field-appearance-outline .mat-form-field-subscript-wrapper {
    padding: 0 !important ;
}

.mat-hint {
  opacity: 0.7;
}

.mat-form-field {
    margin-bottom: 15px;
}

.mat-tooltip {
    font-size: 14px;
}

.mat-header-cell {
    font-size: 16px;
}

.fake-form-field-outline {
    border-radius: 5px;
    border-style: solid;
    border-width: 1px;
}

.fake-form-card {
    box-shadow: none !important;
}

.fake-form-field {
    position: absolute;
    top: -10px;
    left: 7px;
    font-size: 11px !important;
    font-weight: 400;
}

.fake-mat-hint {
    color: black;
    opacity: 0.7;
    margin-bottom: 15px;
    font-size: 75%;
    margin-top: 2px;
    padding-left: 10px;
    padding-right: 10px;
}

.hiddenCustomFields {
    width: 100%;
}

// Overwrite default of 180px so that mat-form-fields are displayed
// well on mobile. This is a quick fix and should be replaced with
// proper common formatting in the future
div.mat-form-field-infix {
  width: 100%;
}

.mat-form-field.resolution-display {
    div.mat-form-field-infix {
       display: flex;
       flex: none;
    }
 }


